using VectorizationBase: OffsetPrecalc, StaticBool, Bit, static, NativeTypes, Index, gep_quote, VectorIndex,
    AbstractMask, NativeTypesExceptBit, AbstractSIMDVector, IndexNoUnroll, AbstractStridedPointer, AbstractSIMD
using VectorizationBase: contiguous_batch_size, contiguous_axis, val_stride_rank, bytestrides, offsets, memory_reference,
    vmaximum, fmap, FloatingTypes, IntegerIndex, LazyMulAdd

LoopVectorization.check_args(::Type{T}, ::Type{T}) where T<:Tropical = true
LoopVectorization.check_type(::Type{Tropical{T}}) where {T} = LoopVectorization.check_type(T)

@inline Base.FastMath.add_fast(a::Tropical, b::Tropical) = Tropical(Base.FastMath.max_fast(content(a), content(b)))

@inline function VectorizationBase._vstore!(
    ptr::AbstractStridedPointer, vu::Tropical{<:VecUnroll{Nm1,W}}, u::Unroll{AU,F,N,AV,W}, a::A, s::S, nt::NT, si::StaticInt{RS}
) where {A<:StaticBool,S<:StaticBool,NT<:StaticBool,RS,AU,F,N,AV,W,Nm1}
    VectorizationBase._vstore!(notropical(ptr), content(vu), u, a, s, nt, si)
end

@inline function VectorizationBase._vstore!(ptr::AbstractStridedPointer, vu::Tropical{<:VecUnroll{Nm1,W}}, u::Unroll{AU,F,N,AV,W}, m::AbstractMask{W}, a::A, s::S, nt::NT, si::StaticInt{RS}
) where {A<:StaticBool,S<:StaticBool,NT<:StaticBool,RS,AU,F,N,AV,W,Nm1}
    VectorizationBase._vstore!(notropical(ptr), content(vu), u, m, a, s, nt, si)
end

@inline function VectorizationBase._vstore!(
    g::G, ptr::AbstractStridedPointer{T,D,C}, vu::Tropical{<:VecUnroll{U,W}}, u::Unroll{AU,F,N,AV,1,M,X,I}, a::A, s::S, nt::NT, si::StaticInt{RS}
) where {T,D,C,U,AU,F,N,W,M,I,G<:Function,AV,A<:StaticBool, S<:StaticBool, NT<:StaticBool, RS,X}
    VectorizationBase._vstore!(g, notropical(ptr), content(vu), u, a, s, nt, si)
end
@inline function VectorizationBase.__vstore!(
    f::F, ptr::Ptr{Tropical{T}}, v::Tropical{T}, i::IntegerIndex, a::A, s::S, nt::NT, si::StaticInt{RS}
) where {T<:NativeTypesExceptBit, F<:Function,A<:StaticBool,S<:StaticBool,NT<:StaticBool,RS}
    VectorizationBase.__vstore!(f, Ptr{T}(ptr), content(v), i, a, s, nt, si)
end
@inline function VectorizationBase.__vstore!(
        ptr::Ptr{Tropical{T}}, v::Tropical{VT}, i::I, m::AbstractMask{W}, a::A, s::S, nt::NT, si::StaticInt{RS}
    ) where {W, T <: NativeTypesExceptBit, VT <: Vec, I <: Index, A <: StaticBool, S <: StaticBool, NT <: StaticBool, RS}
    VectorizationBase.__vstore!(Ptr{T}(ptr), content(v), i, m, a, s, nt, si)
end
@inline function VectorizationBase.__vstore!(
    ptr::Ptr{Tropical{T}}, v::Tropical{VT}, i::VectorIndex{W}, a::A, s::S, nt::NT, si::StaticInt{RS}
) where {T,VT<:Vec,W,S<:StaticBool,A<:StaticBool,NT<:StaticBool,RS}
    VectorizationBase.__vstore!(Ptr{T}(ptr), content(v), i, a, s, nt, si)
end

@inline function VectorizationBase.__vload(ptr::Ptr{Tropical{T}}, i::I, m::AbstractMask, a::A, si::StaticInt{RS})  where {A <: StaticBool, T <: NativeTypes, I <: Index, RS}
    Tropical(VectorizationBase.__vload(Ptr{T}(ptr), i, m, a, si))
end
@inline function VectorizationBase.__vload(ptr::Ptr{Tropical{T}}, i::I, a::A, si::StaticInt{RS}) where {A <: StaticBool, T <: NativeTypes, I <: Index, RS}
    Tropical(VectorizationBase.__vload(Ptr{T}(ptr), i, a, si))
end

@inline function VectorizationBase._vbroadcast(a::Union{Val{W},StaticInt{W}}, s::Tropical{T}, si::StaticInt{RS}) where {W,T,RS}
    Tropical(VectorizationBase._vbroadcast(a, content(s), si))
end

@inline function VectorizationBase.stridedpointer(A::AbstractArray{T}) where {T <: Tropical}
    p, r = memory_reference(A)
    stridedpointer(p, contiguous_axis(A), contiguous_batch_size(A), val_stride_rank(A), bytestrides(A), offsets(A))
end

@inline function VectorizationBase.stridedpointer(
    ptr::Ptr{T}, ::StaticInt{C}, ::StaticInt{B}, ::Val{R}, strd::X, offsets::O
) where {T<:Tropical,C,B,R,N,X<:Tuple{Vararg{Integer,N}},O<:Tuple{Vararg{Integer,N}}}
    VectorizationBase.StridedPointer{T,N,C,B,R,X,O}(ptr, strd, offsets)
end

@inline function notropical(ptr::VectorizationBase.StridedPointer{Tropical{T},N,C,B,R,X,O}) where {T,N,C,B,R,X,O}
    VectorizationBase.StridedPointer{T,N,C,B,R,X,O}(Ptr{T}(ptr.p), ptr.strd, ptr.offsets)
end

@inline function notropical(ptr::OffsetPrecalc{<:Tropical})
    VectorizationBase.OffsetPrecalc(notropical(ptr.ptr), ptr.precalc)
end

@inline function VectorizationBase._vload(ptr::AbstractStridedPointer{Tropical{T}}, u::Unroll, ::A, ::StaticInt{RS}) where {T,A<:StaticBool,RS}
    res = VectorizationBase._vload(notropical(ptr), u, A(), StaticInt{RS}())
    Tropical(res)
end

@inline function VectorizationBase._vload(ptr::AbstractStridedPointer{Tropical{T}}, u::Unroll, m::AbstractMask, ::A, ::StaticInt{RS}) where {T,A<:StaticBool,RS}
    res = VectorizationBase._vload(notropical(ptr), u, m, A(), StaticInt{RS}())
    Tropical(res)
end

@generated function VectorizationBase.zero_vecunroll(::StaticInt{N}, ::StaticInt{W}, ::Type{Tropical{T}}, ::StaticInt{RS}) where {N,W,T,RS}
    quote
        $(Expr(:meta,:inline))
        t = Base.Cartesian.@ntuple $N n -> VectorizationBase._vbroadcast(StaticInt{$W}(), $(zero(Tropical{T}).n), StaticInt{$RS}())
        Tropical(VecUnroll(t))
    end
end

@inline function Base.promote_rule(::Type{Tropical{T1}}, ::Type{Tropical{T2}}) where {T1<:VecUnroll,T2<:Vec}
    Tropical{promote_rule(T1, T2)}
end

@inline function VectorizationBase._vzero(::StaticInt{W}, ::Type{T}, ::StaticInt{RS}) where {W,FT,T<:Tropical{FT},RS}
    Tropical(VectorizationBase._vbroadcast(StaticInt{W}(), zero(T).n, StaticInt{RS}()))
end

# `gep` is a shorthand for "get element pointer"
@inline function VectorizationBase._gep(ptr::Ptr{Tropical{T}}, ::StaticInt{N}, ::StaticInt{RS}) where {N, T <: NativeTypes, RS}
    Ptr{Tropical{T}}(VectorizationBase._gep(Ptr{T}(ptr), StaticInt{N}(), StaticInt{RS}()))
end
@inline function VectorizationBase._gep(ptr::Ptr{Tropical{T}}, i::I, ::StaticInt{RS}) where {I <: IntegerIndex, T <: NativeTypes, RS}
    Ptr{Tropical{T}}(VectorizationBase._gep(Ptr{T}(ptr), i, StaticInt{RS}()))
end
@inline function VectorizationBase._gep(ptr::Ptr{Tropical{T}}, i::LazyMulAdd{M,O,I}, ::StaticInt{RS}) where {T <: NativeTypes, I <: Integer, O, M, RS}
    Ptr{Tropical{T}}(VectorizationBase._gep(Ptr{T}(ptr), i, StaticInt{RS}()))
end

for TP in [:NativeTypes, :AbstractSIMD]
    @eval @inline function Base.fma(x::Tropical{V}, y::Tropical{V}, z::Tropical{V}) where {V<:$TP}
        Tropical(Base.FastMath.max_fast(content(z), Base.FastMath.add_fast(content(x), content(y))))
    end
    @eval @inline function Base.fma(::StaticInt{N}, y::Tropical{V}, z::Tropical{V}) where {N,V<:$TP}
        Base.FastMath.add_fast(Base.FastMath.mul_fast(StaticInt{N}(), y), z)
    end

    for f ∈ [:(Base.:(*)), :(Base.FastMath.mul_fast)]
        @eval begin
            @inline $f(::StaticInt{0}, vx::Tropical{T}) where {T<:$TP} = zero(Tropical{T})
            @inline $f(::StaticInt{1}, vx::Tropical{T}) where {T<:$TP} = vx
            @inline $f(vx::Tropical{T}, ::StaticInt{0}) where {T<:$TP} = zero(Tropical{T})
            @inline $f(vx::Tropical{T}, ::StaticInt{1}) where {T<:$TP} = vx
        end
    end
    for f ∈ [:(Base.:(+)), :(Base.FastMath.add_fast)]
        @eval begin
            @inline $f(::StaticInt{0}, vx::Tropical{T}) where {T<:$TP} = vx
            @inline $f(vx::Tropical{T}, ::StaticInt{0}) where {T<:$TP} = vx
        end
    end
end
# julia 1.5 patch
@inline function VectorizationBase.VecUnroll(data::Tuple{T,Vararg{T,N}}) where {N,T<:Tropical}
    Tropical(VecUnroll(map(content, data)))
end

@inline LoopVectorization.vecmemaybe(x::Tropical) = x
@inline function VectorizationBase.collapse_add(vu::Tropical{VecUnroll{N,W,T,V}}) where {N,W,T,V}
    Tropical(VectorizationBase.collapse_max(content(vu)))
end
@inline function VectorizationBase.contract_add(vu::Tropical{VecUnroll{N,W,T,V}}, ::StaticInt{K}) where {N,W,T,V,K}
    Tropical(VectorizationBase.contract_max(content(vu), StaticInt{K}()))
end
@inline function VectorizationBase.reduced_add(x::Tropical, y::Tropical)
    Tropical(VectorizationBase.reduced_max(content(x), content(y)))
end

@inline function VectorizationBase.ifelse(f::F, m::AbstractMask, v1::Tropical, v2::Tropical, v3::Tropical) where {F}
    Tropical(VectorizationBase.ifelse(m, content(f(v1, v2, v3)), content(v3)))
end

@inline VectorizationBase.vsum(x::Tropical{<:AbstractSIMD}) = Tropical(VectorizationBase.vmaximum(content(x)))

# Overwrite the `mul!` in LinearAlgebra (also changes the behavior of `*` in Base)!
using Octavian
const XTranspose{T} = Transpose{T, <:AbstractVecOrMat{T}}
for TA in [:AbstractMatrix, :XTranspose]
    for TB in [:AbstractMatrix, :XTranspose]
        @eval function LinearAlgebra.mul!(o::AbstractMatrix{T}, a::$TA{T}, b::$TB{T}, α::Number, β::Number) where {T<:Tropical}
            α = _convert_to_tropical(T, α)
            β = _convert_to_tropical(T, β)
            Octavian.matmul!(o, a, b, α, β)
        end
    end
end